
//Problema de Estabilidad 3.5


// ---------------------------------------------------
// Analisis del sistema sin retardo
// ---------------------------------------------------

clc;
// Lugar de raices
clf;
s=%s;
num2=10;
den2=s*(s+4);
GH=syslin('c',num2/den2);
evans(GH)
xgrid;
mtlb_axis([-6 2 -100 100])


// Lugar de raices inverso
num3=-10;
den3=s*(s+4);
GH2=syslin('c',num3/den3);
evans(GH2)
xgrid;
//mtlb_axis([-1.5 0.5 -0.5 0.5])

// Bode 
pth=pwd()
pth=pth+"\bode_lin.sci"
exec(pth)
xdel();
clc();
s=%s;
Gx=syslin("c",10,s*(s+4));
fr=logspace(-3,6,200);
bode(Gx,0.0001,1000,"rad");
hold on
[M,F,w]=bode_asym(Gx,fr,2,"red");


// Nyquist
clear;
clc;
figure(2)
s=%s;
num2=10;
den2=s*(s+4);
GH=syslin('c',num2/den2);
clf();
nyquist(GH,1e-2,10e6,0.1);

// Respuesta a lazo cerrado

clear;
clc;
figure(2)
s=%s;
//numT=10;
//denT=(s*(s+4))+10;
//TLC=syslin('c',numT/denT);
num2=10;
den2=s*(s+4);
G=syslin('c',num2/den2);
H=1;
TLC=G/(1+G*H);
t= 0:0.1:5;
y=csim('step',t,TLC);
y2=1.01*ones(1,length(t));
y3=0.99*ones(1,length(t));
plot(t',y');
hold on;
plot(t',y2');
plot(t',y3');
xgrid;



// ---------------------------------------------------
// Analisis del sistema con retardo
// ---------------------------------------------------
clear;
clc;
// --------- FUNCION PADE ---------------------------------------------------------------------------
// Cálculo de la función retardo por el método de Pade
function [Gr]=Pade(nd,Td)
// nd : Orden de la transferencia
// Td : Retardo
//nd=4;
//Td=1;
s=%s;
Ns=0;
Ds=0;
for j=0:nd
    Ns=Ns+(factorial(2*nd-j)*factorial(nd))/(factorial(2*nd)*factorial(j)*factorial(nd-j))*(-s*Td)^j
    Ds=Ds+(factorial(2*nd-j)*factorial(nd))/(factorial(2*nd)*factorial(j)*factorial(nd-j))*(s*Td)^j 
end
Gr=syslin("c",Ns,Ds)
endfunction;
//--------- FUNCION PADE ---------------------------------------------------------------------------

// Respuesta a lazo Cerrado.
xdel;

s=%s;
num2=10;
den2=s*(s+4);
G=syslin('c',num2/den2);

Td=0.39;
n=5;
Gr=Pade(n,Td)           // Aproximación de Pade
G1=G*Gr;               // Transferencia de Lazo Abiero

H=1;
TLC2=G1/(1+G1*H);
t2= 0:0.1:10;
y2=csim('step',t2,TLC2);
plot(t2',y2');
xgrid;
//mtlb_axis([0 10 -0.2 2.2])

//---------------------------------------------------
// Bode 
bode(G1,0.001,100000000,'rad');





